# module-prestashop 1.7

Prestashop module

## Changelog

### 3.3.2
- feature: checkout list view now groups payment method by country
- update: checkout widget view user experience is much more streamlined
- update: removed unnecessary payment steps from checkout

### 3.3.1
- feature: better logging
- update: payment list is now more user-friendly
- fix: carrier dropdown looks better in mobile view
- fix: carrier methods are now automatically installed
- fix: payments are now visible when there is just one payment method active

### 3.3.0
- feature: added DPD parcel machines
- fix: checkout now uses correct payment display names
- fix: shipping carrier logos are now up-to-date
- fix: card payment cancel endpoint does not throw errors anymore
- fix: payments now return to correct order confirmation page

### 3.2.18
- first-time installation issue fixed
- shipping activation issue
- getPaymentMethods caching enabled by default

### 3.2.17
- SCO-related db structure fix

### 3.2.16
- shipping label page size selectable (A4, A5, A6)
- payment categories can have names (bank links, pay later, credit cards)
- tracking nunbers shown in admin as link and can be included in emails.

### 3.2.15
- MC-specific admin features are shown again in pre-1.7.7 prestashop installations

### 3.2.14
- Omniva EE shipment registration fix

### 3.2.13
- visual and language fixes

### 3.2.12
- 1.7.7.x compatibility - mainly missing module functions in admin
- Refund error handling improved
- Parcel registration error handling improved
- Payment method selection improved, no more skipping accepting terms of service
- Shipping method display improved, only active method has parcel machine selection dropdowns
- Country selection to Omniva parcel service
- Translation fixes
- Discounts are calculated on SCO
- Fixed printing multiple parcel labels at once
- Fixed list view of payment methods
- Payments possible if product is out of stock or stock is not set.

